VERSION 5.00
Begin VB.Form MainForm 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "MCHID Sample VB"
   ClientHeight    =   2580
   ClientLeft      =   5490
   ClientTop       =   4080
   ClientWidth     =   9225
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2580
   ScaleWidth      =   9225
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.Label Label8 
      AutoSize        =   -1  'True
      Caption         =   "Label8"
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   162
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   480
      TabIndex        =   7
      Top             =   2040
      Width           =   720
   End
   Begin VB.Label Label7 
      AutoSize        =   -1  'True
      Caption         =   "Label7"
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   162
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   480
      TabIndex        =   6
      Top             =   1800
      Width           =   720
   End
   Begin VB.Label Label6 
      AutoSize        =   -1  'True
      Caption         =   "Label6"
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   162
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   480
      TabIndex        =   5
      Top             =   1560
      Width           =   720
   End
   Begin VB.Label Label5 
      AutoSize        =   -1  'True
      Caption         =   "Label5"
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   162
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   480
      TabIndex        =   4
      Top             =   1320
      Width           =   720
   End
   Begin VB.Label Label4 
      AutoSize        =   -1  'True
      Caption         =   "Label4"
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   162
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   480
      TabIndex        =   3
      Top             =   1080
      Width           =   720
   End
   Begin VB.Label Label3 
      AutoSize        =   -1  'True
      Caption         =   "Label3"
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   162
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   480
      TabIndex        =   2
      Top             =   840
      Width           =   720
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Label1"
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   162
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   480
      TabIndex        =   1
      Top             =   120
      Width           =   720
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Label2"
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   162
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   480
      TabIndex        =   0
      Top             =   360
      Width           =   720
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' vendor and product IDs
Private Const VendorID = 4660
Private Const ProductID = 1

Private Const CLIType_SDMF = 4
Private Const CLIType_MDMF = 128

Private Const FT_DateTime = 1
Private Const FT_CallerNumber = 2
Private Const FT_CallerName = 7
Private Const FT_CalleeNumber = 34

' read and write buffers
Private Const BufferInSize = 64
Private Const BufferOutSize = 64

Dim BufferIn(0 To BufferInSize)   As Byte
Dim BufferOut(0 To BufferOutSize) As Byte

Dim pArrivedMessage               As String


' ****************************************************************
' when the form loads, connect to the HID controller - pass
' the form window handle so that you can receive notification
' events...
'*****************************************************************
Private Sub Form_Load()
   Label1.Caption = ""
   Label2.Caption = ""
   Label3.Caption = ""
   Label4.Caption = ""
   Label5.Caption = ""
   Label6.Caption = ""
   Label7.Caption = ""
   Label8.Caption = ""
   ConnectToHID (Me.hwnd)
End Sub

'*****************************************************************
' disconnect from the HID controller...
'*****************************************************************
Private Sub Form_Unload(Cancel As Integer)
   'DisconnectFromHID
   End
End Sub

'*****************************************************************
' a HID device has been plugged in...
'*****************************************************************
Public Sub OnPlugged(ByVal pHandle As Long)
   If hidGetVendorID(pHandle) = VendorID And hidGetProductID(pHandle) = ProductID Then
      Label1.Caption = "DEVICE PLUGGED"
   End If
End Sub

'*****************************************************************
' a HID device has been unplugged...
'*****************************************************************
Public Sub OnUnplugged(ByVal pHandle As Long)
   If hidGetVendorID(pHandle) = VendorID And hidGetProductID(pHandle) = ProductID Then
      Label1.Caption = "DEVICE UNPLUGGED"
   End If
End Sub

'*****************************************************************
' controller changed notification - called
' after ALL HID devices are plugged or unplugged
'*****************************************************************
Public Sub OnChanged()
   Dim DeviceHandle As Long
   
   ' get the handle of the device we are interested in, then set
   ' its read notify flag to true - this ensures you get a read
   ' notification message when there is some data to read...
   DeviceHandle = hidGetHandle(VendorID, ProductID)
   hidSetReadNotify DeviceHandle, True
End Sub

'*****************************************************************
' on read event...
'*****************************************************************
Public Sub OnRead(ByVal pHandle As Long)
Dim TextBuffer  As String
Dim Sayaca      As Byte
   
   ' read the data (don't forget, pass the whole array)...
   If hidRead(pHandle, BufferIn(0)) Then
      TextBuffer = ""
      
      For Sayaca = 1 To BufferInSize
         If BufferIn(Sayaca) <> 0 Then TextBuffer = TextBuffer & Chr(BufferIn(Sayaca))
      Next Sayaca
      
      Call DataArrival(TextBuffer)
   End If

End Sub

Private Sub DataArrival(Indata As String)
Dim PortNumber     As String
Dim CLIType        As Byte
Dim PacketLength   As Byte
Dim CliPackage     As String
Dim i              As Integer
   
   If Mid(Indata, 1, 3) = "ENQ" Then
      Call SendData("ACK" & vbCrLf)
   Else
      If Mid(Indata, 1, 3) = "ETB" Then
         Call SendData("ACK" & vbCrLf)
      Else
         If Mid(Indata, 1, 3) = "STA" Then
            Label2.Caption = "Last line event detected : " & Mid(Indata, 5, 100)
         Else
            Call SendData("DCK" & vbCrLf)
         
            PortNumber = Mid(Indata, 1, 1)
            CLIType = Asc(Mid(Indata, 2, 1))
            If (InStr("ABCDS", PortNumber) > 0) And ((CLIType = CLIType_SDMF) Or (CLIType = CLIType_MDMF)) Then
               PacketLength = Asc(Mid(Indata, 3, 1))
               If (PacketLength > 0) And (PacketLength < 64) Then
                  CliPackage = Mid(Indata, 2, PacketLength + 3)
                  If TestCheckDigit(CliPackage, PacketLength) Then Call ManuplatePackage(CLIType, PacketLength, PortNumber, CliPackage)
               End If
            End If
         End If
      End If
   End If

End Sub

Private Function TestCheckDigit(CliPackage As String, PackageLength As Byte) As Boolean
Dim i       As Byte
Dim Res     As Boolean
Dim pDigit  As Integer

   pDigit = 0
   For i = 1 To PackageLength + 2
      pDigit = (pDigit + Asc(Mid(CliPackage, i, 1))) And &HFF
   Next i
   pDigit = (&H100 - pDigit)
   
   TestCheckDigit = (pDigit = Asc(Mid(CliPackage, PackageLength + 3, 1)))
End Function

Private Sub ManuplatePackage(CLIType As Byte, PackageLength As Byte, PortNumber As String, CliPackage As String)
Dim i              As Integer
Dim xLength        As Integer

Dim sDateTime      As String
Dim sCaller        As String
Dim sCallee        As String
Dim sCallerName    As String
Dim sUnknown       As String


   Label3.Caption = "Port Number              : " & PortNumber
   If CLIType = CLIType_SDMF Then
      Label2.Caption = "Packet Type              : SDMF"
   Else
      Label4.Caption = "Packet Type              : MDMF"
   End If
   Label5.Caption = "Packet Length            : " & PackageLength

   sDateTime = ""
   sCaller = ""
   sCallee = ""
   sCallerName = ""
   sUnknown = ""

   If CLIType = CLIType_SDMF Then
      sDateTime = Mid(CliPackage, 3, 8)
      sCaller = Mid(CliPackage, 11, PackageLength - 8)
   Else
      i = 3
      Do While i <= PackageLength
           Select Case Asc(Mid(CliPackage, i, 1))
              Case FT_DateTime:
                  xLength = Asc(Mid(CliPackage, i + 1, 1))
                  sDateTime = Mid(CliPackage, i + 2, xLength)
                  i = i + xLength + 1
              Case FT_CallerNumber:
                  xLength = Asc(Mid(CliPackage, i + 1, 1))
                  sCaller = Mid(CliPackage, i + 2, xLength)
                  i = i + xLength + 1
              Case FT_CalleeNumber:
                  xLength = Asc(Mid(CliPackage, i + 1, 1))
                  sCallee = Mid(CliPackage, i + 2, xLength)
                  i = i + xLength + 1
              Case FT_CallerName:
                  xLength = Asc(Mid(CliPackage, i + 1, 1))
                  sCallerName = Mid(CliPackage, i + 2, xLength)
                  i = i + xLength + 1
              Case Else:
                  xLength = Asc(Mid(CliPackage, i + 1, 1))
                  sUnknown = Mid(CliPackage, i + 2, xLength)
                  i = i + xLength + 1
           End Select
           i = i + 1
      Loop
   End If
   Label6.Caption = "Date And Time (MMDDHHMM) : " & sDateTime
   Label7.Caption = "Caller                   : " & sCaller
   Label8.Caption = "Callee                   : " & sCallee
End Sub


Public Sub SendData(xString As String)
Dim pHandle  As Long
Dim Sayaca   As Integer
Dim Sayacb   As Long

   For Sayaca = 0 To BufferOutSize
      BufferOut(Sayaca) = 0
   Next Sayaca
   
   BufferOut(0) = 0   ' first byte is always the report ID
   For Sayaca = 1 To Len(xString)
      BufferOut(Sayaca) = Asc(Mid(xString, Sayaca, 1)) ' first data item, etc etc
   Next Sayaca
   
   pHandle = hidGetHandle(VendorID, ProductID)
   hidWrite pHandle, BufferOut(0)
   
End Sub
 
